<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfsaleSummary ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfsaleSummary
 * @subpackage Arrays
 */
class ArrayOfsaleSummary extends AbstractStructArrayBase
{
    /**
     * The saleSummary
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\SaleSummary[]
     */
    public $saleSummary;
    /**
     * Constructor method for ArrayOfsaleSummary
     * @uses ArrayOfsaleSummary::setSaleSummary()
     * @param \StructType\SaleSummary[] $saleSummary
     */
    public function __construct(array $saleSummary = array())
    {
        $this
            ->setSaleSummary($saleSummary);
    }
    /**
     * Get saleSummary value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\SaleSummary[]|null
     */
    public function getSaleSummary()
    {
        return isset($this->saleSummary) ? $this->saleSummary : null;
    }
    /**
     * Set saleSummary value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\SaleSummary[] $saleSummary
     * @return \ArrayType\ArrayOfsaleSummary
     */
    public function setSaleSummary(array $saleSummary = array())
    {
        foreach ($saleSummary as $arrayOfsaleSummarySaleSummaryItem) {
            // validation for constraint: itemType
            if (!$arrayOfsaleSummarySaleSummaryItem instanceof \StructType\SaleSummary) {
                throw new \InvalidArgumentException(sprintf('The saleSummary property can only contain items of \StructType\SaleSummary, "%s" given', is_object($arrayOfsaleSummarySaleSummaryItem) ? get_class($arrayOfsaleSummarySaleSummaryItem) : gettype($arrayOfsaleSummarySaleSummaryItem)), __LINE__);
            }
        }
        if (is_null($saleSummary) || (is_array($saleSummary) && empty($saleSummary))) {
            unset($this->saleSummary);
        } else {
            $this->saleSummary = $saleSummary;
        }
        return $this;
    }
    /**
     * Add item to saleSummary value
     * @throws \InvalidArgumentException
     * @param \StructType\SaleSummary $item
     * @return \ArrayType\ArrayOfsaleSummary
     */
    public function addToSaleSummary(\StructType\SaleSummary $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SaleSummary) {
            throw new \InvalidArgumentException(sprintf('The saleSummary property can only contain items of \StructType\SaleSummary, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->saleSummary[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SaleSummary|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SaleSummary|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SaleSummary|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SaleSummary|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SaleSummary|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string saleSummary
     */
    public function getAttributeName()
    {
        return 'saleSummary';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfsaleSummary
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
