<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfupdateItem ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfupdateItem
 * @subpackage Arrays
 */
class ArrayOfupdateItem extends AbstractStructArrayBase
{
    /**
     * The updateItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\UpdateItem[]
     */
    public $updateItem;
    /**
     * Constructor method for ArrayOfupdateItem
     * @uses ArrayOfupdateItem::setUpdateItem()
     * @param \StructType\UpdateItem[] $updateItem
     */
    public function __construct(array $updateItem = array())
    {
        $this
            ->setUpdateItem($updateItem);
    }
    /**
     * Get updateItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\UpdateItem[]|null
     */
    public function getUpdateItem()
    {
        return isset($this->updateItem) ? $this->updateItem : null;
    }
    /**
     * Set updateItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateItem[] $updateItem
     * @return \ArrayType\ArrayOfupdateItem
     */
    public function setUpdateItem(array $updateItem = array())
    {
        foreach ($updateItem as $arrayOfupdateItemUpdateItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfupdateItemUpdateItemItem instanceof \StructType\UpdateItem) {
                throw new \InvalidArgumentException(sprintf('The updateItem property can only contain items of \StructType\UpdateItem, "%s" given', is_object($arrayOfupdateItemUpdateItemItem) ? get_class($arrayOfupdateItemUpdateItemItem) : gettype($arrayOfupdateItemUpdateItemItem)), __LINE__);
            }
        }
        if (is_null($updateItem) || (is_array($updateItem) && empty($updateItem))) {
            unset($this->updateItem);
        } else {
            $this->updateItem = $updateItem;
        }
        return $this;
    }
    /**
     * Add item to updateItem value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateItem $item
     * @return \ArrayType\ArrayOfupdateItem
     */
    public function addToUpdateItem(\StructType\UpdateItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateItem) {
            throw new \InvalidArgumentException(sprintf('The updateItem property can only contain items of \StructType\UpdateItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->updateItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string updateItem
     */
    public function getAttributeName()
    {
        return 'updateItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfupdateItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
