<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Cancel' => '\\StructType\\Cancel',
            'CancelResponse' => '\\StructType\\CancelResponse',
            'Invoke' => '\\StructType\\Invoke',
            'InvokeResponse' => '\\StructType\\InvokeResponse',
            'Progress' => '\\StructType\\Progress',
            'ProgressResponse' => '\\StructType\\ProgressResponse',
            'Query' => '\\StructType\\Query',
            'QueryResponse' => '\\StructType\\QueryResponse',
            'Update' => '\\StructType\\Update',
            'UpdateResponse' => '\\StructType\\UpdateResponse',
            'UpdatePassword' => '\\StructType\\UpdatePassword',
            'UpdatePasswordResponse' => '\\StructType\\UpdatePasswordResponse',
            'cancelRequest' => '\\StructType\\CancelRequest',
            'BaseRequest' => '\\StructType\\BaseRequest',
            'cancelResponse' => '\\StructType\\CancelResponse_1',
            'BaseResponse' => '\\StructType\\BaseResponse',
            'cancelResult' => '\\StructType\\CancelResult',
            'BaseResult' => '\\StructType\\BaseResult',
            'errorDetails' => '\\StructType\\ErrorDetails',
            'invokeRequest' => '\\StructType\\InvokeRequest',
            'loginDetails' => '\\StructType\\LoginDetails',
            'routing' => '\\StructType\\Routing',
            'billingDetails' => '\\StructType\\BillingDetails',
            'storedCardKey' => '\\StructType\\StoredCardKey',
            'mcc6012Details' => '\\StructType\\Mcc6012Details',
            'sale' => '\\StructType\\Sale',
            'ArrayOfitem' => '\\ArrayType\\ArrayOfitem',
            'item' => '\\StructType\\Item',
            'itemDetails' => '\\StructType\\ItemDetails',
            'additionalInfo' => '\\StructType\\AdditionalInfo',
            'contactDetails' => '\\StructType\\ContactDetails',
            'threePartName' => '\\StructType\\ThreePartName',
            'address' => '\\StructType\\Address',
            'contact' => '\\StructType\\Contact',
            'vat' => '\\StructType\\Vat',
            'customerInfo' => '\\StructType\\CustomerInfo',
            'invokeResponse' => '\\StructType\\InvokeResponse_1',
            'invokeResult' => '\\StructType\\InvokeResult',
            'progressRequest' => '\\StructType\\ProgressRequest',
            'progressResponse' => '\\StructType\\ProgressResponse_1',
            'progressResult' => '\\StructType\\ProgressResult',
            'queryRequest' => '\\StructType\\QueryRequest',
            'queryResponse' => '\\StructType\\QueryResponse_1',
            'storeCardResult' => '\\StructType\\StoreCardResult',
            'paymentResult' => '\\StructType\\PaymentResult',
            'paymentDetails' => '\\StructType\\PaymentDetails',
            'paymentHeader' => '\\StructType\\PaymentHeader',
            'authDetails' => '\\StructType\\AuthDetails',
            'surchargeDetails' => '\\StructType\\SurchargeDetails',
            'surchargeBasis' => '\\StructType\\SurchargeBasis',
            'ArrayOfsaleSummary' => '\\ArrayType\\ArrayOfsaleSummary',
            'saleSummary' => '\\StructType\\SaleSummary',
            'ArrayOfpaymentSummary' => '\\ArrayType\\ArrayOfpaymentSummary',
            'paymentSummary' => '\\StructType\\PaymentSummary',
            'updateRequest' => '\\StructType\\UpdateRequest',
            'updateSale' => '\\StructType\\UpdateSale',
            'ArrayOfupdateItem' => '\\ArrayType\\ArrayOfupdateItem',
            'updateItem' => '\\StructType\\UpdateItem',
            'updateResponse' => '\\StructType\\UpdateResponse_1',
            'updateResult' => '\\StructType\\UpdateResult',
            'updatePasswordRequest' => '\\StructType\\UpdatePasswordRequest',
            'updatePasswordResponse' => '\\StructType\\UpdatePasswordResponse_1',
            'updatePasswordResult' => '\\StructType\\UpdatePasswordResult',
            'credentials' => '\\StructType\\Credentials',
            'subject' => '\\StructType\\Subject',
            'requestIdentification' => '\\StructType\\RequestIdentification',
            'signature' => '\\StructType\\Signature',
        );
    }
}
