<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for billingDetails StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:billingDetails
 * @subpackage Structs
 */
class BillingDetails extends AbstractStructBase
{
    /**
     * The storedCardKey
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\StoredCardKey
     */
    public $storedCardKey;
    /**
     * The MCC6012
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Mcc6012Details
     */
    public $MCC6012;
    /**
     * Constructor method for billingDetails
     * @uses BillingDetails::setStoredCardKey()
     * @uses BillingDetails::setMCC6012()
     * @param \StructType\StoredCardKey $storedCardKey
     * @param \StructType\Mcc6012Details $mCC6012
     */
    public function __construct(\StructType\StoredCardKey $storedCardKey = null, \StructType\Mcc6012Details $mCC6012 = null)
    {
        $this
            ->setStoredCardKey($storedCardKey)
            ->setMCC6012($mCC6012);
    }
    /**
     * Get storedCardKey value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\StoredCardKey|null
     */
    public function getStoredCardKey()
    {
        return isset($this->storedCardKey) ? $this->storedCardKey : null;
    }
    /**
     * Set storedCardKey value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\StoredCardKey $storedCardKey
     * @return \StructType\BillingDetails
     */
    public function setStoredCardKey(\StructType\StoredCardKey $storedCardKey = null)
    {
        if (is_null($storedCardKey) || (is_array($storedCardKey) && empty($storedCardKey))) {
            unset($this->storedCardKey);
        } else {
            $this->storedCardKey = $storedCardKey;
        }
        return $this;
    }
    /**
     * Get MCC6012 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Mcc6012Details|null
     */
    public function getMCC6012()
    {
        return isset($this->MCC6012) ? $this->MCC6012 : null;
    }
    /**
     * Set MCC6012 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Mcc6012Details $mCC6012
     * @return \StructType\BillingDetails
     */
    public function setMCC6012(\StructType\Mcc6012Details $mCC6012 = null)
    {
        if (is_null($mCC6012) || (is_array($mCC6012) && empty($mCC6012))) {
            unset($this->MCC6012);
        } else {
            $this->MCC6012 = $mCC6012;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\BillingDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
