<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for errorDetails StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:errorDetails
 * @subpackage Structs
 */
class ErrorDetails extends AbstractStructBase
{
    /**
     * The errorId
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $errorId;
    /**
     * The errorMessage
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $errorMessage;
    /**
     * Constructor method for errorDetails
     * @uses ErrorDetails::setErrorId()
     * @uses ErrorDetails::setErrorMessage()
     * @param string $errorId
     * @param string $errorMessage
     */
    public function __construct($errorId = null, $errorMessage = null)
    {
        $this
            ->setErrorId($errorId)
            ->setErrorMessage($errorMessage);
    }
    /**
     * Get errorId value
     * @return string|null
     */
    public function getErrorId()
    {
        return $this->errorId;
    }
    /**
     * Set errorId value
     * @param string $errorId
     * @return \StructType\ErrorDetails
     */
    public function setErrorId($errorId = null)
    {
        // validation for constraint: string
        if (!is_null($errorId) && !is_string($errorId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorId)), __LINE__);
        }
        $this->errorId = $errorId;
        return $this;
    }
    /**
     * Get errorMessage value
     * @return string|null
     */
    public function getErrorMessage()
    {
        return $this->errorMessage;
    }
    /**
     * Set errorMessage value
     * @param string $errorMessage
     * @return \StructType\ErrorDetails
     */
    public function setErrorMessage($errorMessage = null)
    {
        // validation for constraint: string
        if (!is_null($errorMessage) && !is_string($errorMessage)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errorMessage)), __LINE__);
        }
        $this->errorMessage = $errorMessage;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ErrorDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
