<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for invokeResult StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:invokeResult
 * @subpackage Structs
 */
class InvokeResult extends BaseResult
{
    /**
     * The redirectUrl
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $redirectUrl;
    /**
     * Constructor method for invokeResult
     * @uses InvokeResult::setRedirectUrl()
     * @param string $redirectUrl
     */
    public function __construct($redirectUrl = null)
    {
        $this
            ->setRedirectUrl($redirectUrl);
    }
    /**
     * Get redirectUrl value
     * @return string|null
     */
    public function getRedirectUrl()
    {
        return $this->redirectUrl;
    }
    /**
     * Set redirectUrl value
     * @param string $redirectUrl
     * @return \StructType\InvokeResult
     */
    public function setRedirectUrl($redirectUrl = null)
    {
        // validation for constraint: string
        if (!is_null($redirectUrl) && !is_string($redirectUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($redirectUrl)), __LINE__);
        }
        $this->redirectUrl = $redirectUrl;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\InvokeResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
