<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for loginDetails StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:loginDetails
 * @subpackage Structs
 */
class LoginDetails extends AbstractStructBase
{
    /**
     * The loginName
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $loginName;
    /**
     * The password
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $password;
    /**
     * The consortiumCode
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $consortiumCode;
    /**
     * The siteId
     * @var int
     */
    public $siteId;
    /**
     * Constructor method for loginDetails
     * @uses LoginDetails::setLoginName()
     * @uses LoginDetails::setPassword()
     * @uses LoginDetails::setConsortiumCode()
     * @uses LoginDetails::setSiteId()
     * @param string $loginName
     * @param string $password
     * @param string $consortiumCode
     * @param int $siteId
     */
    public function __construct($loginName = null, $password = null, $consortiumCode = null, $siteId = null)
    {
        $this
            ->setLoginName($loginName)
            ->setPassword($password)
            ->setConsortiumCode($consortiumCode)
            ->setSiteId($siteId);
    }
    /**
     * Get loginName value
     * @return string|null
     */
    public function getLoginName()
    {
        return $this->loginName;
    }
    /**
     * Set loginName value
     * @param string $loginName
     * @return \StructType\LoginDetails
     */
    public function setLoginName($loginName = null)
    {
        // validation for constraint: string
        if (!is_null($loginName) && !is_string($loginName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($loginName)), __LINE__);
        }
        $this->loginName = $loginName;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \StructType\LoginDetails
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get consortiumCode value
     * @return string|null
     */
    public function getConsortiumCode()
    {
        return $this->consortiumCode;
    }
    /**
     * Set consortiumCode value
     * @param string $consortiumCode
     * @return \StructType\LoginDetails
     */
    public function setConsortiumCode($consortiumCode = null)
    {
        // validation for constraint: string
        if (!is_null($consortiumCode) && !is_string($consortiumCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($consortiumCode)), __LINE__);
        }
        $this->consortiumCode = $consortiumCode;
        return $this;
    }
    /**
     * Get siteId value
     * @return int|null
     */
    public function getSiteId()
    {
        return $this->siteId;
    }
    /**
     * Set siteId value
     * @param int $siteId
     * @return \StructType\LoginDetails
     */
    public function setSiteId($siteId = null)
    {
        // validation for constraint: int
        if (!is_null($siteId) && !is_numeric($siteId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($siteId)), __LINE__);
        }
        $this->siteId = $siteId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\LoginDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
