<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for paymentResult StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:paymentResult
 * @subpackage Structs
 */
class PaymentResult extends BaseResult
{
    /**
     * The paymentDetails
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PaymentDetails
     */
    public $paymentDetails;
    /**
     * Constructor method for paymentResult
     * @uses PaymentResult::setPaymentDetails()
     * @param \StructType\PaymentDetails $paymentDetails
     */
    public function __construct(\StructType\PaymentDetails $paymentDetails = null)
    {
        $this
            ->setPaymentDetails($paymentDetails);
    }
    /**
     * Get paymentDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PaymentDetails|null
     */
    public function getPaymentDetails()
    {
        return isset($this->paymentDetails) ? $this->paymentDetails : null;
    }
    /**
     * Set paymentDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\PaymentDetails $paymentDetails
     * @return \StructType\PaymentResult
     */
    public function setPaymentDetails(\StructType\PaymentDetails $paymentDetails = null)
    {
        if (is_null($paymentDetails) || (is_array($paymentDetails) && empty($paymentDetails))) {
            unset($this->paymentDetails);
        } else {
            $this->paymentDetails = $paymentDetails;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\PaymentResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
