<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for requestIdentification StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:requestIdentification
 * @subpackage Structs
 */
class RequestIdentification extends AbstractStructBase
{
    /**
     * The uniqueReference
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $uniqueReference;
    /**
     * The timeStamp
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $timeStamp;
    /**
     * Constructor method for requestIdentification
     * @uses RequestIdentification::setUniqueReference()
     * @uses RequestIdentification::setTimeStamp()
     * @param string $uniqueReference
     * @param string $timeStamp
     */
    public function __construct($uniqueReference = null, $timeStamp = null)
    {
        $this
            ->setUniqueReference($uniqueReference)
            ->setTimeStamp($timeStamp);
    }
    /**
     * Get uniqueReference value
     * @return string|null
     */
    public function getUniqueReference()
    {
        return $this->uniqueReference;
    }
    /**
     * Set uniqueReference value
     * @param string $uniqueReference
     * @return \StructType\RequestIdentification
     */
    public function setUniqueReference($uniqueReference = null)
    {
        // validation for constraint: string
        if (!is_null($uniqueReference) && !is_string($uniqueReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($uniqueReference)), __LINE__);
        }
        $this->uniqueReference = $uniqueReference;
        return $this;
    }
    /**
     * Get timeStamp value
     * @return string|null
     */
    public function getTimeStamp()
    {
        return $this->timeStamp;
    }
    /**
     * Set timeStamp value
     * @param string $timeStamp
     * @return \StructType\RequestIdentification
     */
    public function setTimeStamp($timeStamp = null)
    {
        // validation for constraint: string
        if (!is_null($timeStamp) && !is_string($timeStamp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($timeStamp)), __LINE__);
        }
        $this->timeStamp = $timeStamp;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RequestIdentification
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
