<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for updatePasswordRequest StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:updatePasswordRequest
 * @subpackage Structs
 */
class UpdatePasswordRequest extends AbstractStructBase
{
    /**
     * The credentials
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Credentials
     */
    public $credentials;
    /**
     * The login
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var \StructType\LoginDetails
     */
    public $login;
    /**
     * The requestId
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $requestId;
    /**
     * The newPassword
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var string
     */
    public $newPassword;
    /**
     * Constructor method for updatePasswordRequest
     * @uses UpdatePasswordRequest::setCredentials()
     * @uses UpdatePasswordRequest::setLogin()
     * @uses UpdatePasswordRequest::setRequestId()
     * @uses UpdatePasswordRequest::setNewPassword()
     * @param \StructType\Credentials $credentials
     * @param \StructType\LoginDetails $login
     * @param string $requestId
     * @param string $newPassword
     */
    public function __construct(\StructType\Credentials $credentials = null, \StructType\LoginDetails $login = null, $requestId = null, $newPassword = null)
    {
        $this
            ->setCredentials($credentials)
            ->setLogin($login)
            ->setRequestId($requestId)
            ->setNewPassword($newPassword);
    }
    /**
     * Get credentials value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Credentials|null
     */
    public function getCredentials()
    {
        return isset($this->credentials) ? $this->credentials : null;
    }
    /**
     * Set credentials value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \StructType\Credentials $credentials
     * @return \StructType\UpdatePasswordRequest
     */
    public function setCredentials(\StructType\Credentials $credentials = null)
    {
        if (is_null($credentials) || (is_array($credentials) && empty($credentials))) {
            unset($this->credentials);
        } else {
            $this->credentials = $credentials;
        }
        return $this;
    }
    /**
     * Get login value
     * @return \StructType\LoginDetails|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param \StructType\LoginDetails $login
     * @return \StructType\UpdatePasswordRequest
     */
    public function setLogin(\StructType\LoginDetails $login = null)
    {
        $this->login = $login;
        return $this;
    }
    /**
     * Get requestId value
     * @return string|null
     */
    public function getRequestId()
    {
        return $this->requestId;
    }
    /**
     * Set requestId value
     * @param string $requestId
     * @return \StructType\UpdatePasswordRequest
     */
    public function setRequestId($requestId = null)
    {
        // validation for constraint: string
        if (!is_null($requestId) && !is_string($requestId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($requestId)), __LINE__);
        }
        $this->requestId = $requestId;
        return $this;
    }
    /**
     * Get newPassword value
     * @return string|null
     */
    public function getNewPassword()
    {
        return $this->newPassword;
    }
    /**
     * Set newPassword value
     * @param string $newPassword
     * @return \StructType\UpdatePasswordRequest
     */
    public function setNewPassword($newPassword = null)
    {
        // validation for constraint: string
        if (!is_null($newPassword) && !is_string($newPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($newPassword)), __LINE__);
        }
        $this->newPassword = $newPassword;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\UpdatePasswordRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
